package com.galaxis.wms.utils;

import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.FileUtils;
import org.junit.jupiter.api.Test;
import org.w3c.dom.Document;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;
import java.io.ByteArrayInputStream;
import java.io.File;

/**
 * 作者：lizw <br/>
 * 创建时间：2022/03/17 11:12 <br/>
 */
@Slf4j
public class XPathUtilsTest {

    @SneakyThrows
    @Test
    public void t01() {
        DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
        documentBuilderFactory.setValidating(false);
        documentBuilderFactory.setIgnoringComments(true);
        documentBuilderFactory.setIgnoringElementContentWhitespace(true);

        XPathFactory xPathFactory = XPathFactory.newInstance();

        ByteArrayInputStream inputStream = new ByteArrayInputStream(FileUtils.readFileToByteArray(new File("./src/test/resources/test.xml")));
        long start = System.currentTimeMillis();
        for (int i = 0; i < 100000; i++) {
            DocumentBuilder builder = documentBuilderFactory.newDocumentBuilder();
            XPath xPath = xPathFactory.newXPath();
            Document doc = builder.parse(inputStream);
            inputStream.reset();
            // String expression = "/Envelope/Body/MT_KUNNR_IN_WMS01/arg0/BWKEY";
            String expression = "//MT_KUNNR_IN_WMS01//BWKEY[1]";
            Object res = xPath.evaluate(expression, doc, XPathConstants.STRING);
            if (i == 0) {
                log.info("-> {}", res);
            }
        }
        long end = System.currentTimeMillis();
        log.info("耗时 -> {}ms", end - start);
    }
}
